import java.io.FileNotFoundException;

/**
 * 
 */

/**
 * @author nieminen
 *
 */
public class DemoIris {

    /**
     * @param args
     * @throws FileNotFoundException 
     */
    public static void main(String[] args) throws FileNotFoundException {
        DataSet iris = DataSet.createFromTextFile("iris_numerical.dat",5);
        
        // Make the split to training and testing sets. Ex. 0.4=40%/60%
        iris.shuffledSplitToTrainAndTest(.4);

        SimpleMLP mlp = new SimpleMLP(new int[]{4,20,3});

        for(int i=0;i<100;i++){
            mlp.trainGD(iris.trainInputs(), iris.trainTargets(), 0.1, 200);

            System.out.println("Training set:");
            int[] outclasses = mlp.classifyMatrix(iris.trainInputs());
            DataSet.printConfusion(outclasses,iris.trainTargets());

            System.out.println("Test set:");
            outclasses = mlp.classifyMatrix(iris.testInputs());
            DataSet.printConfusion(outclasses,iris.testTargets());
        }

        /*        double[][] outputs = mlp.feedMatrix(iris.inputs());

        for (double[] o: outputs){
            for(int i=0;i<outputs.length;i++){
                for (int j=0; j<outputs[0].length; j++){
                    System.out.printf("%f",outputs[i][j]);
                    System.out.printf("%s",j==outputs[0].length-1?String.format("%n"):" ");
                }
            }
        }
         */
    }

}
